org.apache.http.impl.client

## Class DefaultRequestDirector

- java.lang.Object
- - org.apache.http.impl.client.DefaultRequestDirector

- All Implemented Interfaces:
    RequestDirector

  Deprecated.
  Do not use.

      @Deprecated
      public class DefaultRequestDirector
      extends Object
      implements RequestDirector

  Default implementation of `RequestDirector`.

  The following parameters can be used to customize the behavior of this class:

  - `CoreProtocolPNames.PROTOCOL_VERSION`
  - `CoreProtocolPNames.STRICT_TRANSFER_ENCODING`
  - `CoreProtocolPNames.HTTP_ELEMENT_CHARSET`
  - `CoreProtocolPNames.USE_EXPECT_CONTINUE`
  - `CoreProtocolPNames.WAIT_FOR_CONTINUE`
  - `CoreProtocolPNames.USER_AGENT`
  - `CoreConnectionPNames.SOCKET_BUFFER_SIZE`
  - `CoreConnectionPNames.MAX_LINE_LENGTH`
  - `CoreConnectionPNames.MAX_HEADER_COUNT`
  - `CoreConnectionPNames.SO_TIMEOUT`
  - `CoreConnectionPNames.SO_LINGER`
  - `CoreConnectionPNames.SO_REUSEADDR`
  - `CoreConnectionPNames.TCP_NODELAY`
  - `CoreConnectionPNames.CONNECTION_TIMEOUT`
  - `CoreConnectionPNames.STALE_CONNECTION_CHECK`
  - `ConnRoutePNames.FORCED_ROUTE`
  - `ConnRoutePNames.LOCAL_ADDRESS`
  - `ConnRoutePNames.DEFAULT_PROXY`
  - `CookieSpecPNames.DATE_PATTERNS`
  - `CookieSpecPNames.SINGLE_COOKIE_HEADER`
  - `AuthPNames.CREDENTIAL_CHARSET`
  - `ClientPNames.COOKIE_POLICY`
  - `ClientPNames.HANDLE_AUTHENTICATION`
  - `ClientPNames.HANDLE_REDIRECTS`
  - `ClientPNames.MAX_REDIRECTS`
  - `ClientPNames.ALLOW_CIRCULAR_REDIRECTS`
  - `ClientPNames.VIRTUAL_HOST`
  - `ClientPNames.DEFAULT_HOST`
  - `ClientPNames.DEFAULT_HEADERS`
  - `ClientPNames.CONN_MANAGER_TIMEOUT`
  Since:
    4.0

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected ClientConnectionManager` | `connManager` Deprecated. The connection manager.
    `protected org.apache.http.protocol.HttpProcessor` | `httpProcessor` Deprecated. The HTTP protocol processor.
    `protected ConnectionKeepAliveStrategy` | `keepAliveStrategy` Deprecated. The keep-alive duration strategy.
    `protected ManagedClientConnection` | `managedConn` Deprecated. The currently allocated connection.
    `protected org.apache.http.params.HttpParams` | `params` Deprecated. The HTTP parameters.
    `protected AuthenticationHandler` | `proxyAuthHandler` Deprecated. The proxy authentication handler.
    `protected AuthState` | `proxyAuthState` Deprecated.
    `protected AuthenticationStrategy` | `proxyAuthStrategy` Deprecated. The proxy authentication handler.
    `protected RedirectHandler` | `redirectHandler` Deprecated. The redirect handler.
    `protected RedirectStrategy` | `redirectStrategy` Deprecated. The redirect strategy.
    `protected org.apache.http.protocol.HttpRequestExecutor` | `requestExec` Deprecated. The request executor.
    `protected HttpRequestRetryHandler` | `retryHandler` Deprecated. The request retry handler.
    `protected org.apache.http.ConnectionReuseStrategy` | `reuseStrategy` Deprecated. The connection re-use strategy.
    `protected HttpRoutePlanner` | `routePlanner` Deprecated. The route planner.
    `protected AuthenticationHandler` | `targetAuthHandler` Deprecated. The target authentication handler.
    `protected AuthState` | `targetAuthState` Deprecated.
    `protected AuthenticationStrategy` | `targetAuthStrategy` Deprecated. The target authentication handler.
    `protected UserTokenHandler` | `userTokenHandler` Deprecated. The user token handler.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultRequestDirector(org.apache.http.protocol.HttpRequestExecutor requestExec, ClientConnectionManager conman, org.apache.http.ConnectionReuseStrategy reustrat, ConnectionKeepAliveStrategy kastrat, HttpRoutePlanner rouplan, org.apache.http.protocol.HttpProcessor httpProcessor, HttpRequestRetryHandler retryHandler, RedirectHandler redirectHandler, AuthenticationHandler targetAuthHandler, AuthenticationHandler proxyAuthHandler, UserTokenHandler userTokenHandler, org.apache.http.params.HttpParams params)` Deprecated.
    `DefaultRequestDirector(org.apache.commons.logging.Log log, org.apache.http.protocol.HttpRequestExecutor requestExec, ClientConnectionManager conman, org.apache.http.ConnectionReuseStrategy reustrat, ConnectionKeepAliveStrategy kastrat, HttpRoutePlanner rouplan, org.apache.http.protocol.HttpProcessor httpProcessor, HttpRequestRetryHandler retryHandler, RedirectStrategy redirectStrategy, AuthenticationHandler targetAuthHandler, AuthenticationHandler proxyAuthHandler, UserTokenHandler userTokenHandler, org.apache.http.params.HttpParams params)` Deprecated.
    `DefaultRequestDirector(org.apache.commons.logging.Log log, org.apache.http.protocol.HttpRequestExecutor requestExec, ClientConnectionManager conman, org.apache.http.ConnectionReuseStrategy reustrat, ConnectionKeepAliveStrategy kastrat, HttpRoutePlanner rouplan, org.apache.http.protocol.HttpProcessor httpProcessor, HttpRequestRetryHandler retryHandler, RedirectStrategy redirectStrategy, AuthenticationStrategy targetAuthStrategy, AuthenticationStrategy proxyAuthStrategy, UserTokenHandler userTokenHandler, org.apache.http.params.HttpParams params)` Deprecated.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected org.apache.http.HttpRequest` | `createConnectRequest(HttpRoute route, org.apache.http.protocol.HttpContext context)` Deprecated. Creates the CONNECT request for tunnelling.
    `protected boolean` | `createTunnelToProxy(HttpRoute route, int hop, org.apache.http.protocol.HttpContext context)` Deprecated. Creates a tunnel to an intermediate proxy.
    `protected boolean` | `createTunnelToTarget(HttpRoute route, org.apache.http.protocol.HttpContext context)` Deprecated. Creates a tunnel to the target server.
    `protected HttpRoute` | `determineRoute(org.apache.http.HttpHost targetHost, org.apache.http.HttpRequest request, org.apache.http.protocol.HttpContext context)` Deprecated. Determines the route for a request.
    `protected void` | `establishRoute(HttpRoute route, org.apache.http.protocol.HttpContext context)` Deprecated. Establishes the target route.
    `org.apache.http.HttpResponse` | `execute(org.apache.http.HttpHost targetHost, org.apache.http.HttpRequest request, org.apache.http.protocol.HttpContext context)` Deprecated. Executes a request.
    `protected RoutedRequest` | `handleResponse(RoutedRequest roureq, org.apache.http.HttpResponse response, org.apache.http.protocol.HttpContext context)` Deprecated. Analyzes a response to check need for a followup.
    `protected void` | `releaseConnection()` Deprecated. Returns the connection back to the connection manager and prepares for retrieving a new connection during the next request.
    `protected void` | `rewriteRequestURI(RequestWrapper request, HttpRoute route)` Deprecated.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### connManager

          protected final ClientConnectionManager connManager

      Deprecated.
      The connection manager.

    - #### routePlanner

          protected final HttpRoutePlanner routePlanner

      Deprecated.
      The route planner.

    - #### reuseStrategy

          protected final org.apache.http.ConnectionReuseStrategy reuseStrategy

      Deprecated.
      The connection re-use strategy.

    - #### keepAliveStrategy

          protected final ConnectionKeepAliveStrategy keepAliveStrategy

      Deprecated.
      The keep-alive duration strategy.

    - #### requestExec

          protected final org.apache.http.protocol.HttpRequestExecutor requestExec

      Deprecated.
      The request executor.

    - #### httpProcessor

          protected final org.apache.http.protocol.HttpProcessor httpProcessor

      Deprecated.
      The HTTP protocol processor.

    - #### retryHandler

          protected final HttpRequestRetryHandler retryHandler

      Deprecated.
      The request retry handler.

    - #### redirectHandler

          protected final RedirectHandler redirectHandler

      Deprecated.
      The redirect handler.

    - #### redirectStrategy

          protected final RedirectStrategy redirectStrategy

      Deprecated.
      The redirect strategy.

    - #### targetAuthHandler

          protected final AuthenticationHandler targetAuthHandler

      Deprecated.
      The target authentication handler.

    - #### targetAuthStrategy

          protected final AuthenticationStrategy targetAuthStrategy

      Deprecated.
      The target authentication handler.

    - #### proxyAuthHandler

          protected final AuthenticationHandler proxyAuthHandler

      Deprecated.
      The proxy authentication handler.

    - #### proxyAuthStrategy

          protected final AuthenticationStrategy proxyAuthStrategy

      Deprecated.
      The proxy authentication handler.

    - #### userTokenHandler

          protected final UserTokenHandler userTokenHandler

      Deprecated.
      The user token handler.

    - #### params

          protected final org.apache.http.params.HttpParams params

      Deprecated.
      The HTTP parameters.

    - #### managedConn

          protected ManagedClientConnection managedConn

      Deprecated.
      The currently allocated connection.

    - #### targetAuthState

          protected final AuthState targetAuthState

      Deprecated.

    - #### proxyAuthState

          protected final AuthState proxyAuthState

      Deprecated.

  - ### Constructor Detail

    - #### DefaultRequestDirector

          public DefaultRequestDirector(org.apache.http.protocol.HttpRequestExecutor requestExec,
                                ClientConnectionManager conman,
                                org.apache.http.ConnectionReuseStrategy reustrat,
                                ConnectionKeepAliveStrategy kastrat,
                                HttpRoutePlanner rouplan,
                                org.apache.http.protocol.HttpProcessor httpProcessor,
                                HttpRequestRetryHandler retryHandler,
                                RedirectHandler redirectHandler,
                                AuthenticationHandler targetAuthHandler,
                                AuthenticationHandler proxyAuthHandler,
                                UserTokenHandler userTokenHandler,
                                org.apache.http.params.HttpParams params)

      Deprecated.

    - #### DefaultRequestDirector

          public DefaultRequestDirector(org.apache.commons.logging.Log log,
                                org.apache.http.protocol.HttpRequestExecutor requestExec,
                                ClientConnectionManager conman,
                                org.apache.http.ConnectionReuseStrategy reustrat,
                                ConnectionKeepAliveStrategy kastrat,
                                HttpRoutePlanner rouplan,
                                org.apache.http.protocol.HttpProcessor httpProcessor,
                                HttpRequestRetryHandler retryHandler,
                                RedirectStrategy redirectStrategy,
                                AuthenticationHandler targetAuthHandler,
                                AuthenticationHandler proxyAuthHandler,
                                UserTokenHandler userTokenHandler,
                                org.apache.http.params.HttpParams params)

      Deprecated.

    - #### DefaultRequestDirector

          public DefaultRequestDirector(org.apache.commons.logging.Log log,
                                org.apache.http.protocol.HttpRequestExecutor requestExec,
                                ClientConnectionManager conman,
                                org.apache.http.ConnectionReuseStrategy reustrat,
                                ConnectionKeepAliveStrategy kastrat,
                                HttpRoutePlanner rouplan,
                                org.apache.http.protocol.HttpProcessor httpProcessor,
                                HttpRequestRetryHandler retryHandler,
                                RedirectStrategy redirectStrategy,
                                AuthenticationStrategy targetAuthStrategy,
                                AuthenticationStrategy proxyAuthStrategy,
                                UserTokenHandler userTokenHandler,
                                org.apache.http.params.HttpParams params)

      Deprecated.
      Since:
        4.2

  - ### Method Detail

    - #### rewriteRequestURI

          protected void rewriteRequestURI(RequestWrapper request,
                               HttpRoute route)
                                    throws org.apache.http.ProtocolException

      Deprecated.
      Throws:
        `org.apache.http.ProtocolException`

    - #### execute

          public org.apache.http.HttpResponse execute(org.apache.http.HttpHost targetHost,
                                             org.apache.http.HttpRequest request,
                                             org.apache.http.protocol.HttpContext context)
                                               throws org.apache.http.HttpException,
                                                      IOException

      Deprecated.
      Description copied from interface: `RequestDirector`
      Executes a request.

      Note: For the time being, a new director is instantiated for each request. This is the same behavior as for `HttpMethodDirector` in HttpClient 3.

      Specified by:
        `execute` in interface `RequestDirector`
      Parameters:
        `targetHost` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `context` - the context for executing the request
      Returns:
        the final response to the request. This is never an intermediate response with status code 1xx.
      Throws:
        `org.apache.http.HttpException` - in case of a problem
        `IOException` - in case of an IO problem or if the connection was aborted

    - #### releaseConnection

          protected void releaseConnection()

      Deprecated.
      Returns the connection back to the connection manager and prepares for retrieving a new connection during the next request.

    - #### determineRoute

          protected HttpRoute determineRoute(org.apache.http.HttpHost targetHost,
                                 org.apache.http.HttpRequest request,
                                 org.apache.http.protocol.HttpContext context)
                                      throws org.apache.http.HttpException

      Deprecated.
      Determines the route for a request. Called by `execute(org.apache.http.HttpHost, org.apache.http.HttpRequest, org.apache.http.protocol.HttpContext)` to determine the route for either the original or a followup request.
      Parameters:
        `targetHost` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `context` - the context to use for the execution, never `null`
      Returns:
        the route the request should take
      Throws:
        `org.apache.http.HttpException` - in case of a problem

    - #### establishRoute

          protected void establishRoute(HttpRoute route,
                            org.apache.http.protocol.HttpContext context)
                                 throws org.apache.http.HttpException,
                                        IOException

      Deprecated.
      Establishes the target route.
      Parameters:
        `route` - the route to establish
        `context` - the context for the request execution
      Throws:
        `org.apache.http.HttpException` - in case of a problem
        `IOException` - in case of an IO problem

    - #### createTunnelToTarget

          protected boolean createTunnelToTarget(HttpRoute route,
                                     org.apache.http.protocol.HttpContext context)
                                          throws org.apache.http.HttpException,
                                                 IOException

      Deprecated.
      Creates a tunnel to the target server. The connection must be established to the (last) proxy. A CONNECT request for tunnelling through the proxy will be created and sent, the response received and checked. This method does not update the connection with information about the tunnel, that is left to the caller.
      Parameters:
        `route` - the route to establish
        `context` - the context for request execution
      Returns:
        `true` if the tunnelled route is secure, `false` otherwise. The implementation here always returns `false`, but derived classes may override.
      Throws:
        `org.apache.http.HttpException` - in case of a problem
        `IOException` - in case of an IO problem

    - #### createTunnelToProxy

          protected boolean createTunnelToProxy(HttpRoute route,
                                    int hop,
                                    org.apache.http.protocol.HttpContext context)
                                         throws org.apache.http.HttpException,
                                                IOException

      Deprecated.
      Creates a tunnel to an intermediate proxy. This method is not implemented in this class. It just throws an exception here.
      Parameters:
        `route` - the route to establish
        `hop` - the hop in the route to establish now. `route.getHopTarget(hop)` will return the proxy to tunnel to.
        `context` - the context for request execution
      Returns:
        `true` if the partially tunnelled connection is secure, `false` otherwise.
      Throws:
        `org.apache.http.HttpException` - in case of a problem
        `IOException` - in case of an IO problem

    - #### createConnectRequest

          protected org.apache.http.HttpRequest createConnectRequest(HttpRoute route,
                                                         org.apache.http.protocol.HttpContext context)

      Deprecated.
      Creates the CONNECT request for tunnelling. Called by `createTunnelToTarget`.
      Parameters:
        `route` - the route to establish
        `context` - the context for request execution
      Returns:
        the CONNECT request for tunnelling

    - #### handleResponse

          protected RoutedRequest handleResponse(RoutedRequest roureq,
                                     org.apache.http.HttpResponse response,
                                     org.apache.http.protocol.HttpContext context)
                                          throws org.apache.http.HttpException,
                                                 IOException

      Deprecated.
      Analyzes a response to check need for a followup.
      Parameters:
        `roureq` - the request and route.
        `response` - the response to analayze
        `context` - the context used for the current request execution
      Returns:
        the followup request and route if there is a followup, or `null` if the response should be returned as is
      Throws:
        `org.apache.http.HttpException` - in case of a problem
        `IOException` - in case of an IO problem

Copyright © 1999–2022 The Apache Software Foundation. All rights reserved.